# skript zacina importem potrebnych modulu, coz jsou soubory obsahujici preddefinovane funkce slouzici k praci s daty:


import os
import arcpy
from arcpy import env
import sys
import string


# po uvodnim hlaseni nasleduje dotaz na cestu ke kontrolovanym datum prostrednictvim prikazu raw_input:
print " "
print "                 VITEJTE V TOPOCONTROL "
print " "
print "______________________________________________________________"
print " "


cesta_k_minis = raw_input("Zadejte, prosim, cestu k datum: ")


print " "
print "______________________________________________________________"
print " "

# seznam vsech vrstev, ktere muze uzemni plan zpracovany na zaklade metodiky MINIS obsahovat:
data_up = ["ResUz_p.shp", "ZU_p.shp", "RZV_p.shp", "RP_p.shp", "USR_p.shp", "UR_p.shp", "VPZP_p.shp", "VPZL_l.shp", "VPZB_b.shp", "USES_p.shp"]


# seznam vrstev povinnych a vrstev nepovinne odevzdavanych (opet vychazi z definice MINIS):
data_up_povinna = ["ResUz_p.shp", "ZU_p.shp", "RZV_p.shp", "RP_p.shp" ]
print "Povinne Shapefily dle standardu MINIS:"
print data_up_povinna
print " "

data_up_volitelna = ["UR_p.shp", "VPZP_p.shp", "VPZL_l.shp", "VPZB_b.shp", "USES_p.shp", "USR_p.shp" ]
print "Volitelne zpracovane Shapefily dle standardu MINIS:"
print data_up_volitelna

# vytvoreni zatim prazdneho adresare data_up_import, do nejz budou vkladany vrstvy z vyse uvedenych seznamu - predejde se tak kontrole dat, ktera do standardizovaneho UP nepatri
data_up_import = []

print " "
print "______________________________________________________________"
print " "


# definice pracovniho prostredi a funkce fcList, s jejiz pomoci je vytvoren seznam dostupnych vrstev na adrese cesta_k_minis
env.workspace = cesta_k_minis
fcList = arcpy.ListFeatureClasses()

# overeni existence povinne odevzdavanych vrstev:
print "POVINNE VRSTVY NA ADRESE cesta_k_minis:"
print " "
for fc in data_up_povinna:
    if fc in fcList:
        print fc + " existuje"
        data_up_import.append(string.replace(fc, ".shp", ""))
    else:
        print fc + " neexistuje"
        print "Z DUVODU ABSENCE POVINNYCH VRTSTEV BYL SKRIPT UKONCEN!"
        sys.exit()

print " "
print " "

# kontrola nepovinnych vrstev:
print "NEPOVINNE VRSTVY NA ADRESE cesta_k_minis:"
print " "

for fc in data_up_volitelna:
    if fc in fcList:
        print fc + " existuje"
        data_up_import.append(string.replace(fc, ".shp", ""))
    else:
        print fc + " neexistuje"

# vypsani seznamu vrstev, ktere jsou urceny pro dalsi kontrolu:        
print " "
print "SEZNAM VRSTEV PRO IMPORT DO KONTROLNI SLOZKY:"
print " "
print data_up_import


print " "
print "______________________________________________________________"
print " "


# kontrola spravne nastaveneho souradnicoveho systemu (S-JTSK - Krovakovo zobrazeni), v pripade spatne definice je skript ukoncen:

env.workspace = cesta_k_minis
fcList = arcpy.ListFeatureClasses()

for infc in data_up_import:

    dsc = arcpy.Describe(infc + ".shp")
    sr = dsc.spatialReference

    if sr.Name == "S-JTSK_Krovak_East_North":
        continue

    else:
        print "!SHAPEFILE %s MA SPATNE DEFINOVANY SOURADNICOVY SYSTEM!" % fc
        print "SKRIPT BYL Z DOVODU SPATNE DEFINOVANEHO SOURADNICOVEHO SYSTEMU UKONCEN"
        sys.exit()
        
print "Vsechny Shapefily maji spravne definovany souradnicovy system"
print " "

# kontrola spravne nastaveneho geometrickeho typu jednotlivych vrstev (Polygon, Polyline, Point), v pripade spatne definice je skript ukoncen:

data_up_geometry_types = ["Polygon", "Polyline", "Point"]

for infc in data_up_import:

    dsc = arcpy.Describe(infc + ".shp")
    shapeType = dsc.shapeType

    if shapeType in data_up_geometry_types:
        continue
        
    else:
        print fc + "Geometricky typ je SPATNE"
        print "SKRIPT BYL Z DUVODU SPATNE DEFINOVANEHO GEOMATRICKEHO TYPU U NEKTERE Z VRSTEV UKONCEN"
        sys.exit()

        
print "Geometricky typ vsech Shapefilu je OK"
print " "


# nyni data prosla zakladni obsahovou kontrolou - vime, jake vrstvy mame k dispozici a ze zadna z povinnych vrstev nechybi a ze souradnicovy system i geometricke typy jednotlivych trid jsou spravne definovany
# dale bude vytvorena novy slozka na adrese cesta_k_minis + geodb, v ni geodatabaze, v geodatabazi dataset a nad datasetem zatim prazdna topologicka vrstva:



# vytvoreni nove slozky na adrese "cesta_k_minis" a v ni nove geodatabaze :

geodb_dir = cesta_k_minis + "geodb"
geodb_name = "minis_topologie.mdb"

os.mkdir(geodb_dir)

arcpy.CreatePersonalGDB_management(geodb_dir, geodb_name)

print "Byla vytvorena nova geodatabaze minis_topologie"
print " "



# nastaveni promennou minis_topologie_mdb jakozto umisteni pro novy dataset
minis_topologie_mdb = geodb_dir + "\\minis_topologie.mdb"


# vytvoreni kontrolniho datasetu pouzitim nastroje Create Feature Dataset:
arcpy.CreateFeatureDataset_management(minis_topologie_mdb, "kontrolni_dataset", "PROJCS['S-JTSK_Krovak_East_North',GEOGCS['GCS_S_JTSK',DATUM['D_S_JTSK',SPHEROID['Bessel_1841',6377397.155,299.1528128]],PRIMEM['Greenwich',0.0],UNIT['Degree',0.0174532925199433]],PROJECTION['Krovak'],PARAMETER['False_Easting',0.0],PARAMETER['False_Northing',0.0],PARAMETER['Pseudo_Standard_Parallel_1',78.5],PARAMETER['Scale_Factor',0.9999],PARAMETER['Azimuth',30.28813975277778],PARAMETER['Longitude_Of_Center',24.83333333333333],PARAMETER['Latitude_Of_Center',49.5],PARAMETER['X_Scale',-1.0],PARAMETER['Y_Scale',1.0],PARAMETER['XY_Plane_Rotation',90.0],UNIT['Meter',1.0]];-33699800 -33699800 133638764.246984;-100000 10000;-100000 10000;0.001;0.001;0.001;IsHighPrecision")

print "V geodatabazi minis_topologie byl vytvoren kontrolni dataset"
print " "



# nastaveni promenne kontrolni_dataset jakozto datasetu, nad nimz bude topologie vytvorena:
kontrolni_dataset = minis_topologie_mdb + "\\kontrolni_dataset"

# provedeni nastroj Create Topology a vytvoreni topologie nad datasetem ResUz_p
arcpy.CreateTopology_management(kontrolni_dataset, "kontrolni_dataset_topology", "0.1")

print "Nad kontrolnim datasetem byla vytvorena topologie"
print " "
print "Do datasetu budou nyni kopirovany dostupne vrstvy:"
print " "

kontrolni_topologie = geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\kontrolni_dataset_topology"



# nyni budou do datasetu, nad nimz byla vytvorena topologie, kopirovany vrstvy ze seznamu data_up_import:


for fc in data_up_import:
    print "Kopiruji " + fc
    arcpy.CopyFeatures_management(fc + ".shp", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset" + os.sep + fc)
  

print " "
print "Do kontrolniho datasetu byly kopirovany jednotlive vrstvy z puvodni slozky"
print " "
print "_____________________________________________________________________________"
print " "

# vsechny vrstvy, ktere byly prave zkopirovany do kontrolniho datasetu, budou zaroven pridany do topologie

print "Vrstvy budou nyni vlozeny do jiz vytvorene topologie:"

env.workspace = kontrolni_dataset


for fc in data_up_import:
    print "Vkladam " + fc + " do topologie"
    arcpy.AddFeatureClassToTopology_management(kontrolni_topologie, geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset" + os.sep + fc)


print " "
print "Vsechny dostupne vrstvy byly vlozeny do topologie"
print " "
print "_____________________________________________________________________________"
print " "

# nyni budou na vrstvy v topologii aplikovana topologicka pravidla:

print "Zacinam definovat topologicka pravidla pro jednotlive vrstvy. Tato operace muze tvat nekolik minut, prosim, neprerusujte beh skriptu."
env.workspace = kontrolni_dataset
fcList = arcpy.ListFeatureClasses()

if "ResUz_p" in fcList:
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Have Gaps (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", "", "", )

        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Overlap (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", "", "", )


if "RP_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Overlap (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\RP_p", "", "", "", )


if "RZV_p" in fcList:
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Have Gaps (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\RZV_p", "", "", "", )

        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Overlap (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\RZV_p", "", "", "", )


if "UR_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Overlap (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\UR_p", "", "", "", )


if "USES_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Overlap (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\USES_p", "", "", "", )


if "USR_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Overlap (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\USR_p", "", "", "", )


if "VPZP_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Overlap (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\VPZP_p", "", "", "", )


if "ZU_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Not Overlap (Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ZU_p", "", "", "", )


if "ResUz_p" and "RP_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Be Covered By (Area-Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\RP_p", "", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", )


if "ResUz_p" and "UR_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Be Covered By (Area-Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\UR_p", "", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", )


if "ResUz_p" and "USES_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Be Covered By (Area-Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\USES_p", "", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", )


if "ResUz_p" and "USR_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Be Covered By (Area-Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\USR_p", "", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", )


if "ResUz_p" and "VPZP_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Be Covered By (Area-Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\VPZP_p", "", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", )



if "ZU_p" and "ResUz_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Be Covered By (Area-Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ZU_p", "", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", )



if "RZV_p" and "ResUz_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Cover Each Other (Area-Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\RZV_p", "", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", )




if "VPZB_b" and "ResUz_p" in fcList:
        
        arcpy.AddRuleToTopology_management(kontrolni_topologie, "Must Be Properly Inside (Point-Area)", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\VPZB_b", "", geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\ResUz_p", "", )



# na dostupne vrstvy byla aplikovana pozadovana pravidla, nyni zbyva topologii zvalidovat:

arcpy.ValidateTopology_management(geodb_dir + "\\minis_topologie.mdb\\kontrolni_dataset\\kontrolni_dataset_topology")

print " "
print "Do topologie byla vlozena vsechna aplikovatelna pravidla. Topologie byla zvalidovana. Vytvorenou topologickou vrstvu naleznete na adrese cesta_k_minis\\Data_UPgeodb\\minis_topologie.mdb\\kontrolni_dataset\\kontrolni_dataset_topology. Pro dalsi praci s daty vyuzijte nektery z nastroju softwaru ArcGIS."


